/****************************************************************************************

		DXF.H.h

		Copyright (c)1990 - 1999 MetaCreations. All rights reserved.

		Definitions shared by the C++ files and the resource definition files (.r)


		Author: Pierre-E

		Date:	7/16/99

		Revision History

		when		who			what & why
		==========	==========	======================================================
		08/31/99	cph			fix to use new import/export API
		8/20/99		cph			added include for I3DShScene.h

*****************************************************************************************/


#ifndef __PSK__
#define __PSK__

#include "MCCompObj.h"
#include "PSKDef.h"
#include "Basic3DImportExport.h"
#include "MCBasicTypes.h"
#include "APITypes.h"
#include "COMUtilities.h"
#include "I3DShScene.h"

#include <stdlib.h>
#include <stdio.h>

//carrara5 - July 2007
#include <string.h>
#include "I3dRenderingModule.h"
//

#include "IShComponent.h"
#include "I3DExVertexPrimitive.h"
#include "IPolymesh.h"
#include "IPolygon.h"
#include "IShTextureMap.h"
#include "I3DShShader.h"
#include "I3dExSkinable.h"
#include "BonesUtilities.h"
#include "SkiningTypes.h"
#include "I3dShAnimationMethod.h"
#include "I3DShTweener.h"
#include "I3DShKeyFrame.h"
#include "I3dShAnimation.h"
#include "PMapTypes.h"
#include "I3dShUtilities.h"
#include "COM3DUtilities.h"



extern const MCGUID CLSID_PSK;

class TPSKExporter : public TBasic3DExportFilter
{
public:
	STANDARD_RELEASE;

	// for 3D exporters elem maps to I3DShScene and subElem maps toI3DShTreeElement through QueryInterface
	virtual MCCOMErr 	MCCOMAPI DoExport	(IMCFile * file, I3DShScene* scene, I3DShTreeElement* fatherTree);
};

class FQuat
{
public:
	float X,Y,Z,W;
};
class FVector
{
public:
	float X,Y,Z;
};
struct VJointPos
{
	FQuat Orientation;
	FVector Position;
	float Length;
	float XSize;
	float YSize;
	float ZSize;
};
struct VBone
{
	char Name[64];
	unsigned int Flags;
	int NumChildren;
	int ParentIndex;
	VJointPos BonePos;
};
struct VRawBoneInfluence
{
	float Weight;
	int PointIndex;
	int BoneIndex;
};
struct AnimInfoBinary
{
	char Name[64];     // Animation's name
	char Group[64];    // Animation's group name	

	int TotalBones;           // TotalBones * NumRawFrames is number of animation keys to digest.

	int RootInclude;          // 0 none 1 included 	(unused)
	int KeyCompressionStyle;  // Reserved: variants in tradeoffs for compression.
	int KeyQuotum;            // Max key quotum for compression	
	float KeyReduction;       // desired 
	float TrackTime;          // explicit - can be overridden by the animation rate
	float AnimRate;           // frames per second.
	int StartBone;            // - Reserved: for partial animations (unused)
	int FirstRawFrame;        //
	int NumRawFrames;         // NumRawFrames and AnimRate dictate tracktime...
};
// File header structure. 
struct VChunkHeader
{
	char			ChunkID[20];  // String ID of up to 19 chars (usually zero-terminated)
	int	TypeFlag;     // Flags/reserved
	int     DataSize;     // Size per struct following;
	int     DataCount;    // Number of structs/
};
//
// An animation key.
//struct VQuatAnimKey
struct VQuatAnimKey
{
	FVector		Position;           // Relative to parent.
	FQuat       Orientation;        // Relative to parent.
	float       Time;				// The duration until the next key (end key wraps to first...)
};
// vpoint structure
struct VPoint
{
	FVector Point;
};

struct VVertexUn
{
	unsigned short PointIndex;
	float U,V;
	char MatIndex;
	char Reserved;

};
struct VTriangle
{
	unsigned short WedgeIndex[3];
	char MatIndex;
	char AuxMatIndex;
	unsigned int SmoothingGroups;
};
struct VMaterial
{
	char MaterialName[64];
	int TextureIndex;
	unsigned int PolyFlags;
	int AuxMaterial;
	unsigned int AuxFlags;
	int LodBias;
	int LodStyle;
};
#endif
