/****************************************************************************************

PSK.CPP

28-November-2004 export from carrara to Unreal psk psa formats
test is good for recursive navigation of tree
06-December-2004 survey
select the root bone
get mesh attached to joint
passes tree starting with root bone to exploreskel
NEXT: 1st get the file name then write binary file of mesh with bone information

binary write is good 1999801 dec became 30c79 hex in file
ready to start writing real data
08-Dec		plan get nbr verts from ipolymesh
only allow 1 polymesh test and return
ipolymesh has everything that is needed
use polygon to get texture info via loop through polygon faces
can get uv index but then how get uv's??
get uv index of polygons vertex and use it in the corresponding vertex data
12-Dec point header looks good
next points
24-Dec ok compiled no errors but how test - modify truespace reader? Yes but write text file 
next uv and materials - get facetmesh and tye uv/point to polymesh point indexes
polymesh must be triangulated so only one facet per polygon

25-Dec-2004 debugging file working check of points looks good
next get facetmesh
got initial vvertex but found that uv's for points repeated so vvertex will be redundant and some values will not be used
there is no exclusive uv array so no other way
26-Dec-2004 material build is good, dummy bone and influences import to unreal success
2 problems bone invisible but can see bone name
object inside out - try negative Y
non unique vvertex is a problem - need to build it from scratch not just read facetmesh
DEFINETLY need build vvertex while building triangles - the only way
27-Dec-2004 shape is good and texture is good, but still no support for 1 texture many shading domains yet
NEXT do real skeleton
29-Dec read quat from transform now do skeleton and read joint transforms
check if local transform use in place of zero parent
DIRECT READ OF LOCAL TRANSFORM IS GOOD
maybe problem with quat - first was off then did again and was perfect
skeleton now shows in unrealed(2 bones so it shows)
31-Dec bone hierarchy is good TODO remove sapces from bone names(maybe spaces are OK)
just need to do influences and will be ready for vehicle style exporting
animation maybe easy because can read local transforms
31-December-2004 PSK is fully operational
todo - test then add animation PSA
01-January-2005 all is done except PSA - waiting for info from users group
08-Jan-2005 start coding animation stuff
			got base single xyz key code to build and run w/o errors
			09-Jan-2005 looking good debug file shows values are good except for first bone(local sb global)
			had to hard code 18 fps for now
			need transform from local to global for first bone

09-January-2005 FIRST FULLY FUNCTIONAL VERSION
				MESH, BONES AND ANIMATION ALL WORKING
15-January-2005 tracktime was wrong
				psa is raw frames not keyframes - need to rewrite animation hard code to 18 fps for now
				status: correct num frames but gets to end of motion at frame 1
				ok it's fixed now
				root rotation is opposite - seems to be the last problem
				ROOT ROTATION IS FIXED - inverse matrix did it - READY FOR DISTRIBUTION

19-March-2005	header type is incorrect
				change 199801 to 1999801
				change 198801 to 1999801
				may fix KAT incompatibility problem
				real problem in materials header
				change MAT0000 to MATT0000

*****************************************************************************************/

#include <math.h>
#include "PSK.h"

#include "MCColorRGBA.h"
#include "I3DShScene.h"
#include "I3DShGroup.h"
#include "I3DShInstance.h"
#include "ISHUtilities.h"
#include "MCBasicTypes.h"
#include "PublicUtilities.h"
#include "I3DShCamera.h"
#include "I3DShLightSource.h"
#include "I3DShObject.h"
#include "MCColor16.h"
#include "ColorRGB214.h"
#include "IShColorConversionUtilities.h"

#include "I3DShJoint.h"

#define kManyFacetsError 0x2BC
#define kStandardFacetsError 0x1000
#define kFewfacetsError	0x2000
#define SQR(X) (X*X)

const MCGUID CLSID_PSK={R_CLSID_PSK};

void Extension3DInit(IMCUnknown* utilities)
{
	// Perform your dll initialization here
}

void Extension3DCleanup()
{
	// Perform any nec clean-up here
}

TBasicUnknown* MakeCOMObject(const MCCLSID& classId)	// This method instanciate
{														// the object COM
	TBasicUnknown* res = NULL;

	if (classId == CLSID_PSK) res = new TPSKExporter;

	return res;
}


uint16 ToUint16(int16 x) 
{
	return x*2;
}

int SkelIndex;
class FQuat
{
public:
	float X,Y,Z,W;
};
class FVector
{
public:
	float X,Y,Z;
};
struct VJointPos
{
	FQuat Orientation;
	FVector Position;
	float Length;
	float XSize;
	float YSize;
	float ZSize;
};
struct VBone
{
	char Name[64];
	unsigned int Flags;
	int NumChildren;
	int ParentIndex;
	VJointPos BonePos;
};
struct VRawBoneInfluence
{
	float Weight;
	int PointIndex;
	int BoneIndex;
};
struct AnimInfoBinary
{
	char Name[64];     // Animation's name
	char Group[64];    // Animation's group name	

	int TotalBones;           // TotalBones * NumRawFrames is number of animation keys to digest.

	int RootInclude;          // 0 none 1 included 	(unused)
	int KeyCompressionStyle;  // Reserved: variants in tradeoffs for compression.
	int KeyQuotum;            // Max key quotum for compression	
	float KeyReduction;       // desired 
	float TrackTime;          // explicit - can be overridden by the animation rate
	float AnimRate;           // frames per second.
	int StartBone;            // - Reserved: for partial animations (unused)
	int FirstRawFrame;        //
	int NumRawFrames;         // NumRawFrames and AnimRate dictate tracktime...
};
// File header structure. 
struct VChunkHeader
{
	char			ChunkID[20];  // String ID of up to 19 chars (usually zero-terminated)
	int	TypeFlag;     // Flags/reserved
	int     DataSize;     // Size per struct following;
	int     DataCount;    // Number of structs/
};
//
VChunkHeader MyBoneHeader, MyBoneInfHeader;
AnimInfoBinary MyAnimInfo[1]; // one animation at a time
// An animation key.
struct VQuatAnimKey
{
	FVector		Position;           // Relative to parent.
	FQuat       Orientation;        // Relative to parent.
	float       Time;				// The duration until the next key (end key wraps to first...)
};
VQuatAnimKey MyAnimKey[300000]; 
VBone MyVBone[200];// 2 time UDN Male
VRawBoneInfluence MyBoneInf[5000];

// vpoint structure
struct VPoint
{
	FVector Point;
};

struct VVertexUn
{
	unsigned short PointIndex;
	float U,V;
	char MatIndex;
	char Reserved;

};
struct VTriangle
{
	unsigned short WedgeIndex[3];
	char MatIndex;
	char AuxMatIndex;
	unsigned int SmoothingGroups;
};
struct VMaterial
{
	char MaterialName[64];
	int TextureIndex;
	unsigned int PolyFlags;
	int AuxMaterial;
	unsigned int AuxFlags;
	int LodBias;
	int LodStyle;
};

VChunkHeader MyFileHeader, MyPointHeader,MyWedgeHeader, MyVTriangleHeader, MyVMatHeader;

VPoint MyVPoint[5000];
VVertexUn MyVVertex[10000];
VTriangle MyVTriangle[10000];
VMaterial MyVMaterial[8];

I3DShTreeElement* ParentTElement[200];//note must be on seperate lines or get error
I3DShTreeElement* TElement[200];
// animation - x,y,z and rotation
I3DShAnimationMethod* pMyAnimMethod;
I3DShParamTimeLine* pMyTimeLine[800];

int SkelTIndex;

VChunkHeader MyAnimInfoHeader,MyVQuatAnimHeader;

void WriteAnim()
{
	strcpy(MyFileHeader.ChunkID,"ANIMHEAD");
	MyFileHeader.TypeFlag = 1999801;
	MyFileHeader.DataSize = 0;
	MyFileHeader.DataCount = 0;

	strcpy(MyBoneHeader.ChunkID,"BONENAMES");
	MyBoneHeader.TypeFlag = 1999801;
	MyBoneHeader.DataSize = sizeof(VBone);
	MyBoneHeader.DataCount = SkelIndex + 1;

	strcpy(MyAnimInfoHeader.ChunkID,"ANIMINFO");
	MyAnimInfoHeader.TypeFlag = 1999801;
	MyAnimInfoHeader.DataSize = sizeof(AnimInfoBinary);
	MyAnimInfoHeader.DataCount = 1;// one animation

	strcpy(MyAnimInfo[0].Name,"DummyAnim");
	strcpy(MyAnimInfo[0].Group,"None");
	MyAnimInfo[0].TotalBones = MyBoneHeader.DataCount;

	MyAnimInfo[0].RootInclude = 0;
	MyAnimInfo[0].KeyCompressionStyle = 0;
	//set in buildanim()
	//MyAnimInfo[i].KeyQuotum = MyBoneHeader.DataCount * numFrames;
	MyAnimInfo[0].KeyReduction = 1;
	//MyAnimInfo[0].TrackTime = MyAnimInfo[0].KeyQuotum / MyBoneHeader.DataCount;
	MyAnimInfo[0].AnimRate = 18;//hardcode 18 fps
	MyAnimInfo[0].StartBone = 0;
	MyAnimInfo[0].FirstRawFrame = 0;//only one animation

	//MyAnimInfo[0].NumRawFrames = MyAnimInfo[0].TrackTime;
	MyAnimInfo[0].NumRawFrames = MyAnimInfo[0].KeyQuotum / MyBoneHeader.DataCount;

	strcpy(MyVQuatAnimHeader.ChunkID,"ANIMKEYS");
	MyVQuatAnimHeader.TypeFlag = 1999801;
	MyVQuatAnimHeader.DataSize = sizeof(VQuatAnimKey);
	MyVQuatAnimHeader.DataCount = MyAnimInfo[0].KeyQuotum;//only one animation

	FILE *fp2;
	if((fp2=fopen("Carranim.psa","wb")) != NULL)
	{
		fwrite(&MyFileHeader,sizeof(VChunkHeader),1,fp2);

		fwrite(&MyBoneHeader,sizeof(VChunkHeader),1,fp2);
		fwrite(&MyVBone,sizeof(VBone),MyBoneHeader.DataCount,fp2);

		fwrite(&MyAnimInfoHeader,sizeof(VChunkHeader),1,fp2);
		fwrite(&MyAnimInfo,sizeof(AnimInfoBinary),MyAnimInfoHeader.DataCount,fp2);

		fwrite(&MyVQuatAnimHeader,sizeof(VChunkHeader),1,fp2);
		fwrite(&MyAnimKey,sizeof(VQuatAnimKey),MyVQuatAnimHeader.DataCount,fp2);

		fclose(fp2);
	}
}
void BuildAnim(TMCfstream* stream, bool PSAtest)
{
	char szBuffer[192];
	int32 timeLineCount = SkelTIndex+4;
	TMatrix33 MyMatrix, MyInvMatrix;
	TUnitQuaternion MyQuat;
	boolean success=true;

	//(*stream)<<"time line count is ";
	//(*stream)<<timeLineCount;
	//(*stream)<<"\n";

	TMCClassArray<TTimeInfo> lastKeyFrame;
	lastKeyFrame.SetElemCount(timeLineCount);

	int32 i=0;
	int32 ii,iii=0;
	float timeInSeconds=0;

	for (i=0;i<timeLineCount;i++)
	{
		lastKeyFrame[i].SetToBeforeAll();
	}
	MicroTick time = -1;
	MicroTick previousTime = -2;
	MicroTick ticksPerFrame,j;

	ticksPerFrame = real(kTicksPerSecond)/18;//assume 18 fps

	while (time > previousTime)
	{
		previousTime= time;

		// first we look for the smallest keyFrame of X,Y,Z that is bigger than previousTime
		// ( note that we export one keyFrame for the 3 coordinates )
		for (i=0;i<timeLineCount;i++)
		{
			if ( lastKeyFrame[i].GetTime() <= previousTime )
			{
				TMCCountedPtr<I3DShTweenerChainLink> tweenerChainLink;
				TTimeInfo newKeyFrame;

				pMyTimeLine[i]->WhenIsNextKeyFrame(lastKeyFrame[i],newKeyFrame,&tweenerChainLink);

				lastKeyFrame[i] = newKeyFrame;

				MicroTick newTime = newKeyFrame.GetTime();

				/*
				(*stream)<<"line newtime prevtime time ";
				(*stream)<<i;
				(*stream)<<" ";
				(*stream)<<newTime;
				(*stream)<<" ";
				(*stream)<<previousTime;
				(*stream)<<" ";
				(*stream)<<time;
				(*stream)<<" ";
				(*stream)<<"\n";
				*/

				// newTime > previousTime enforces that we move forward in time
				// time==previousTime makes sure that we get one first value
				// newTime < time makes sure we get the smallest time possible
				if (newTime > previousTime && (time==previousTime || newTime < time))
				{
					time = newTime;
				}
			}
		}

		// if we have been able to find a new keyFrame
		if (time > previousTime)
		{
			// we have a new keyFrame
			TVector3 keyFrameValue(0,0,0);

			TMCCountedPtr<I3DShTweenerChainLink> tweenerChainLink;
			if(time != previousTime+ticksPerFrame && previousTime != -1)//not first key at zero and something to interpolate
			{
				for(j=previousTime+ticksPerFrame;j<time;j=j+ticksPerFrame)
				{
					for (i=0;i<timeLineCount;i++)
					{
						pMyTimeLine[i]->GetPreviousLink(j,&tweenerChainLink);//get tweener previous to time j

						ii = i%4;//x,y,z,rotation
						TMCCountedPtr<I3DShKeyFrame> keyFrame;

						// if xyz if rotation use kMatrix33ParamType
						if(ii<3) gShell3DUtilities->CreateKeyFrame(&keyFrame,kReal32ParamType);
						if(ii==3) gShell3DUtilities->CreateKeyFrame(&keyFrame,kMatrix33ParamType);

						if (true)
						{
							// check if the keyframe is the last of the list or not
							if(tweenerChainLink->GetNextNoAddRef())
							{
								TMCCountedPtr<I3DShTweener> tweener;

								tweenerChainLink->GetTweener(&tweener, true);
								if (MCVerify(tweener))
								{
									// do the interpolation using the tweener
									tweener->Tween(keyFrame, j, tweenerChainLink);
								}
							}
							else
					{
						keyFrame->LinearInterpolate(kRealZero,
							tweenerChainLink->GetKeyFrameNoAddRef(),
							tweenerChainLink->GetKeyFrameNoAddRef());
					}

							boolean changed= false;
							real value=0.0f;// only xyz need matrix33 for rotation
							TMatrix33 Rvalue;

							if(ii<3) keyFrame->GetParam(&value,kReal32ParamType,changed);
							if(ii==3) keyFrame->GetParam(&Rvalue,kMatrix33ParamType,changed);

							if(ii==0) MyAnimKey[iii].Position.X = value;
							if(ii==1) MyAnimKey[iii].Position.Y = value;
							if(ii==2) MyAnimKey[iii].Position.Z = value;
							if(ii==3)
							{
								
								if(i==3) Rvalue = Rvalue.Inverse(&success);//rootbone 
								MyQuat.SetFromMatrix(Rvalue);
								MyAnimKey[iii].Orientation.W = MyQuat.GetT();
								MyAnimKey[iii].Orientation.X = MyQuat.GetX();
								MyAnimKey[iii].Orientation.Y = MyQuat.GetY();
								MyAnimKey[iii].Orientation.Z = MyQuat.GetZ();

								MyAnimKey[iii].Time = 1;

								iii = iii + 1;//unreal key count

							}
						}//keyFrame
					}
				}
			}
			for (i=0;i<timeLineCount;i++)
			{
				pMyTimeLine[i]->GetPreviousLink(time,&tweenerChainLink);

				ii = i%4;//x,y,z,rotation
				TMCCountedPtr<I3DShKeyFrame> keyFrame;

				// if xyz if rotation use kMatrix33ParamType
				if(ii<3) gShell3DUtilities->CreateKeyFrame(&keyFrame,kReal32ParamType);
				if(ii==3) gShell3DUtilities->CreateKeyFrame(&keyFrame,kMatrix33ParamType);

				if (MCVerify(keyFrame&&tweenerChainLink))
				{
					// check if the keyframe is the last of the list or not
					if(tweenerChainLink->GetNextNoAddRef())
					{
						TMCCountedPtr<I3DShTweener> tweener;

						tweenerChainLink->GetTweener(&tweener, true);
						if (MCVerify(tweener))
						{
							// do the interpolation using the tweener
							tweener->Tween(keyFrame, time, tweenerChainLink);
						}
					}
					else
					{
						keyFrame->LinearInterpolate(kRealZero,
							tweenerChainLink->GetKeyFrameNoAddRef(),
							tweenerChainLink->GetKeyFrameNoAddRef());
					}

					boolean changed= false;
					real value=0.0f;// only xyz need matrix33 for rotation
					TMatrix33 Rvalue;

					if(ii<3) keyFrame->GetParam(&value,kReal32ParamType,changed);
					if(ii==3) keyFrame->GetParam(&Rvalue,kMatrix33ParamType,changed);

					if(ii==0) MyAnimKey[iii].Position.X = value;
					if(ii==1) MyAnimKey[iii].Position.Y = value;
					if(ii==2) MyAnimKey[iii].Position.Z = value;
					if(ii==3)
					{
						if(i==3) Rvalue = Rvalue.Inverse(&success);//rootbone 
						MyQuat.SetFromMatrix(Rvalue);
						MyAnimKey[iii].Orientation.W = MyQuat.GetT();
						MyAnimKey[iii].Orientation.X = MyQuat.GetX();
						MyAnimKey[iii].Orientation.Y = MyQuat.GetY();
						MyAnimKey[iii].Orientation.Z = MyQuat.GetZ();

						MyAnimKey[iii].Time = time - previousTime;

						timeInSeconds = 18 * real(time) / real(kTicksPerSecond);
						/*
						(*stream)<<"time frame is ";
						(*stream)<<timeInSeconds;
						(*stream)<<"\n";

						sprintf(szBuffer,"bone %i posn (xyz)  %f, %f, %f\n\n", iii, MyAnimKey[iii].Position.X, 
							MyAnimKey[iii].Position.Y, MyAnimKey[iii].Position.Z);
						(*stream)<<szBuffer;
						sprintf(szBuffer,"bone %i quat(txyz)   %f, %f, %f, %f\n\n", iii, MyQuat.GetT(), MyQuat.GetX(), MyQuat.GetY(), MyQuat.GetZ());
						(*stream)<<szBuffer;
						*/

						iii = iii + 1;//unreal key count

					}
				}//keyFrame
			}

			float timeInSeconds = real(time) / real(kTicksPerSecond);

			//keyFrameValue is now ready

		} // if (time > previous Time )
	}
	float MyFR = gShell3DUtilities->GetPreferedFrameRate();
	
	MyAnimInfo[0].KeyQuotum = iii;//num bones * num frames
	MyAnimInfo[0].TrackTime = MyAnimKey[iii-1].Time;// in frames

	/*
	(*stream)<<"last key time is ";
	(*stream)<<time;
	(*stream)<<"\n";
	(*stream)<<"ktickspersecond is ";
	(*stream)<<kTicksPerSecond;
	(*stream)<<"\n time in seconds is ";
	(*stream)<<timeInSeconds;
	(*stream)<<"\n";
	(*stream)<<"frame rate is ";
	(*stream)<<MyFR;
	(*stream)<<"\n";
	*/

}
void ExploreSkel(TMCfstream* stream, I3DShTreeElement* tree)
{
	char szBuffer[192];


	//write name and parents name

	// Calc Name
	TMCString1023 name;
	tree->GetName(name);

	int8 p[15],pp[15];
	name.ToCPtr(p);
	/*
	sprintf(szBuffer,"\t*NODE_NAME \"%s\"\n",p);
	(*stream)<<szBuffer;
	*/
	SkelIndex = SkelIndex + 1;
	if(SkelIndex==0)
	{
		ParentTElement[0]=tree;
	}
	else
	{
		tree->GetTop(&ParentTElement[SkelIndex]);
	}
	TElement[SkelIndex] = tree;
	tree->GetAnimationMethod(&pMyAnimMethod);// note format - GetAnimationMethod(I3DShAnimationMethod** animationmethod)
	SkelTIndex = SkelIndex * 4;// x,y,z,rot
	pMyAnimMethod->GetXTranslationAnimationTrack(&pMyTimeLine[SkelTIndex]);
	pMyAnimMethod->GetYTranslationAnimationTrack(&pMyTimeLine[SkelTIndex+1]);
	pMyAnimMethod->GetZTranslationAnimationTrack(&pMyTimeLine[SkelTIndex+2]);
	pMyAnimMethod->GetRotationAnimationTrack(&pMyTimeLine[SkelTIndex+3]);

	//null timeline check didn't work
	/*if(&pMyTimeLine[SkelTIndex] != NULL) 
	{
		(*stream)<<"   Bone has animation";
		(*stream)<<"\n";
	}*/

	ParentTElement[SkelIndex]->GetName(name);
	name.ToCPtr(pp);
	/*
	sprintf(szBuffer,"\t\t*parent NODE_NAME \"%s\"\n",pp);
	(*stream)<<szBuffer;
	*/
	// get local transform
	TUnitQuaternion MyQuat;

	TTreeTransform MyLocal;
	TTransform3D My3DT;
	TMatrix33 MyMatrix, MyInvMatrix;
	TVector3 MyRelLoc;
	//change to local so can match animation part
	/*
	if(SkelIndex==0)
		tree->GetGlobalTreeTransform(MyLocal);
	else
	*/
		tree->GetLocalTreeTransform(MyLocal);

	MyMatrix = MyLocal.fRotation;
	MyRelLoc = MyLocal.fOffset;

	boolean success=true;
	if(SkelIndex==0) MyMatrix = MyMatrix.Inverse(&success);
	/*
	 if(SkelIndex==0)
	 {
		 My3DT = tree->GetInverseGlobalTransform3D();
		 MyMatrix = My3DT.fRotationAndScale;
		 MyRelLoc = My3DT.fTranslation;
	 }
	 */

	/*
	causes exception
	boolean *goodinv;
	if(SkelIndex==0)
	{
		MyInvMatrix = MyMatrix.Inverse(goodinv);
		MyMatrix = MyInvMatrix;
	}
	*/
	


	/*
	sprintf(szBuffer,"local posn   %f, %f, %f\n\n", MyRelLoc.x, MyRelLoc.y, MyRelLoc.z);
	(*stream)<<szBuffer;
	*/

	/*
	sprintf(szBuffer,"local   %f, %f, %f\n", MyMatrix[0][0], MyMatrix[0][1], MyMatrix[0][2]);
	(*stream)<<szBuffer;
	sprintf(szBuffer,"local   %f, %f, %f\n", MyMatrix[1][0], MyMatrix[1][1], MyMatrix[1][2]);
	(*stream)<<szBuffer;
	sprintf(szBuffer,"local   %f, %f, %f\n\n", MyMatrix[2][0], MyMatrix[2][1], MyMatrix[2][2]);
	(*stream)<<szBuffer;
	*/
	MyQuat.SetFromMatrix(MyMatrix);
	/*
	sprintf(szBuffer,"quat(txyz)   %f, %f, %f, %f\n\n", MyQuat.GetT(), MyQuat.GetX(), MyQuat.GetY(), MyQuat.GetZ());
	(*stream)<<szBuffer;
	*/

	strcpy(MyVBone[SkelIndex].Name,p);

	MyVBone[SkelIndex].Flags = 0;
	MyVBone[SkelIndex].NumChildren = 0;
	//TODO - loop to find parent match
	int parIndex;
	if(SkelIndex==0)
	{
		MyVBone[SkelIndex].ParentIndex = 0;
	}
	else
	{
		for(int i=0;i<SkelIndex;i++)
		{
			//use name to find match
			if(strcmp(MyVBone[i].Name,pp)==0) parIndex = i;
		}
		MyVBone[SkelIndex].ParentIndex = parIndex;
	}

	MyVBone[SkelIndex].BonePos.Position.X = MyRelLoc.x;
	MyVBone[SkelIndex].BonePos.Position.Y = MyRelLoc.y;
	MyVBone[SkelIndex].BonePos.Position.Z = MyRelLoc.z;

	MyVBone[SkelIndex].BonePos.Orientation.W = MyQuat.GetT();
	MyVBone[SkelIndex].BonePos.Orientation.X = MyQuat.GetX();
	MyVBone[SkelIndex].BonePos.Orientation.Y = MyQuat.GetY();
	MyVBone[SkelIndex].BonePos.Orientation.Z = MyQuat.GetZ();


	// get global transform
	TTreeTransform MyGlobal;
	tree->GetGlobalTreeTransform(MyGlobal);
	MyMatrix = MyGlobal.fRotation;
	/*
	sprintf(szBuffer,"global   %f, %f, %f\n", MyMatrix[0][0], MyMatrix[0][1], MyMatrix[0][2]);
	(*stream)<<szBuffer;
	sprintf(szBuffer,"global   %f, %f, %f\n", MyMatrix[1][0], MyMatrix[1][1], MyMatrix[1][2]);
	(*stream)<<szBuffer;
	sprintf(szBuffer,"global   %f, %f, %f\n", MyMatrix[2][0], MyMatrix[2][1], MyMatrix[2][2]);
	(*stream)<<szBuffer;
	*/

	TMCCountedPtr<I3DShTreeElement>	MyChild;

	tree->GetFirst(&MyChild);
	while(MyChild != NULL)
	{
		ExploreSkel(stream, MyChild);
		MyChild->GetRight(&MyChild);
	}

}

//########################################################################################

MCCOMErr TPSKExporter::DoExport(IMCFile * file, I3DShScene* scene, I3DShTreeElement* fatherTree)
{
	TMCfstream* stream = NULL;
	uint32 nbInst = 0;

	TMCCountedPtr<IMCUnknown> progressKey;
	try
	{
		nbInst =scene->GetInstanceListCount();

		// Progress bar
		TMCString255 progressMsg;
		void* oldResources = NULL;
		gResourceUtilities->SetupComponentResources('3Dou', 'RPSK', &oldResources);
		gResourceUtilities->GetIndString(progressMsg, 131, 1);		// string  1 of STR# 131 (see DXF.r)
		gResourceUtilities->RestoreComponentResources(oldResources);

		gShellUtilities->BeginProgress(progressMsg, &progressKey, nbInst);

		// Open the file
		TMCString1023 fullPathName;
		file->GetFileFullPathName(fullPathName);

		// do binary file here
		FILE *fp;
		char szFileName[132];
		char szBuffer[192];

		//szFileName = fullPathName.StrGet();
		strcpy(szFileName,fullPathName.StrGet());

		strcpy(MyFileHeader.ChunkID,"ACTRHEAD");
		MyFileHeader.TypeFlag = 1999801;
		MyFileHeader.DataSize = 0;
		MyFileHeader.DataCount = 0;

		/*
		stream = new TMCfstream("C:\\My Documents\\pskout.txt",TMCiostream::out);
		ThrowIfNil(stream);	

		stream->SetInfo(gShellUtilities->GetCreator(), IDTYPE('T', 'E', 'X', 'T'));
		*/
		

		//get polymesh
		// fatherTree will be the bone
		// get mesh from skeleton
		TMCCountedPtr<I3DShJoint> rootjoint;
		fatherTree->QueryInterface(IID_I3DShJoint, (void **) &rootjoint);
		if(rootjoint)
		{

			TMCPtrArray<I3DShPrimitive> primlist;
			//			uint32 numfaces, numvertices;
			TMCString1023 name;

			//			int8 p[15];

			rootjoint->GetAttachedPrimitives(primlist);

			//TMCCountedPtr<I3DShPrimitive> prim;

			TMCCountedPtr<I3DShExternalPrimitive> exprim;

			primlist[0]->QueryInterface(IID_I3DShExternalPrimitive, (void **) &exprim);

			if(exprim)
			{
				//do it here
				// start debugging file

				
				/*
				(*stream)<< fullPathName.StrGet();
				(*stream)<<"\n";
				*/
				

				//texture setup

				TMCString1023 name,name2,name3;

				int8 masterShaderName[15],mytextfilename[15];
				TMCCountedPtr<IShTextureMap> colorMap;
				TMCCountedPtr<I3DShMasterShader> mastershader;

				I3DShObject *pMyObject;
				pMyObject = primlist[0]->GetI3DShObject();
				TMCCountedPtrArray<I3DShInstance> anInstance;
				pMyObject->GetInstanceArray(anInstance); 
				anInstance[0]->GetShader(&mastershader);

				TMCCountedPtr<I3DShShader> shader;
				mastershader->GetShader(&shader);//shader root tree
				mastershader->GetName(name2);
				name2.ToCPtr(masterShaderName);

				TMCCountedPtr<IMCFile> mapFile;
				IDType mapFormat=0;// mac file type?

				// dont need deformed object(only skeleton will deform points only need default pose)
				// get transform

				// this section gives exception error
				TTreeTransform MyTransform;
				TMCCountedPtr<I3DShTreeElement>	tree;
				fatherTree->QueryInterface(IID_I3DShTreeElement, (void**) &tree);

				//use primlist[0] to get transform instead of skeleton
				anInstance[0]->QueryInterface(IID_I3DShTreeElement, (void**) &tree);

				tree->GetGlobalTreeTransform(MyTransform);

				// start by getting points(vertices) of polymesh
				TMCCountedPtr<IShComponent> component;
				exprim->GetPrimitiveComponent(&component);
				ThrowIfNil(component);

				TMCCountedPtr<I3DShPrimitiveComponent> primcomponent;
				component->QueryInterface(IID_I3DShPrimitiveComponent, (void**) &primcomponent);

				TMCCountedPtr<I3DExVertexPrimitive> vertexprim;
				primcomponent->QueryInterface(IID_I3DExVertexPrimitive, (void**) &vertexprim);

				long totnumVerts, numPolyM = vertexprim->GetNbPolymeshes();

				TMCCountedPtr<IPolymesh> mypolym;
				vertexprim->GetPolymesh(&mypolym, 0);// only one polymesh allowed
				totnumVerts = mypolym->GetNbVertices();

				/*
				(*stream)<<"points\n";
				(*stream)<<totnumVerts;
				(*stream)<<"\n";
				*/


				strcpy(MyPointHeader.ChunkID,"PNTS0000");
				MyPointHeader.TypeFlag = 1999801;
				MyPointHeader.DataSize = sizeof(VPoint);
				MyPointHeader.DataCount = totnumVerts;

				//build skeleton data
				SkelIndex = -1;
				
				ExploreSkel(stream, fatherTree);

				// animation
				bool PSAtest = false;
				BuildAnim(stream, PSAtest);

				//get joint array
				I3dExSkinable *MySkinable;

				// get skinable from vertex primitive
				vertexprim->QueryInterface(IID_I3dExSkinable, (void **) &MySkinable);
				TMCPtrArray<I3DShJoint> pMyJoints;
				MySkinable->GetJoints(pMyJoints);
				const TMCArray<TWeightedJoint> *pMyWeights;
				
				TJointIndex MyJointIndex;
				real32 jweight;
				int elemCount,inf,skelcnt,wcount=0,boneMatch;
				TWeightedJoint MyWeight;
				I3DShJoint *pMyJoint;
				I3DShTreeElement *pCmpTree;
				int8 p[15],pp[15];


				VPoint MyVPoint[5000];
				I3DExVertex *pMyVertex;
				TVector3 vertPos, vertPosT;
				for(long vindex=0;vindex<totnumVerts;vindex++)
				{
					pMyVertex = mypolym->GetVertexNoAddRef(vindex);
					pMyWeights = pMyVertex->GetSkiningData(MyJointIndex); 
					elemCount = pMyWeights->GetElemCount(); 

					for(inf=0;inf<elemCount;inf++)
					{
						pMyWeights->GetElem(inf, MyWeight);
						jweight = MyWeight.fWeight;
						MyJointIndex = MyWeight.fIndex;
						/*
						(*stream)<<vindex;
						(*stream)<<"  point ind has ";
						(*stream)<<"joint index and weight   ";
						(*stream)<<MyJointIndex.GetIndex();
						(*stream)<<"   ";
						(*stream)<<MyWeight.fWeight;
						(*stream)<<"\n";
						*/
						//now use joint index to get joint
						pMyJoint = pMyJoints[MyJointIndex.GetIndex()];
						//get tree from joint
						pCmpTree = pMyJoint->GetTreeElement();
						//match tree with unreal skel to get index
						for(skelcnt=0;skelcnt<SkelIndex+1;skelcnt++)
						{
							//tree->GetName(name);
							TElement[skelcnt]->GetName(name);
							name.ToCPtr(p);
							pCmpTree->GetName(name);
							name.ToCPtr(pp);
							if(strcmp(p,pp)==0) boneMatch = skelcnt;
						}
						MyBoneInf[wcount].BoneIndex = boneMatch;
						MyBoneInf[wcount].PointIndex = vindex;
						MyBoneInf[wcount].Weight = MyWeight.fWeight;
						wcount = wcount + 1;

					}



					pMyVertex->GetPosition(vertPos);
					//transform it
					MyTransform.Transform(vertPos,vertPosT);
					//save it
					MyVPoint[vindex].Point.X = vertPosT.x;
					MyVPoint[vindex].Point.Y = vertPosT.y;
					MyVPoint[vindex].Point.Z = vertPosT.z;
					/*
					sprintf(szBuffer,"point %i   %f, %f, %f\n", vindex, vertPosT.x, vertPosT.y, vertPosT.z);
					(*stream)<<szBuffer;
					*/


				}
				strcpy(MyBoneInfHeader.ChunkID,"RAWWEIGHTS");
				MyBoneInfHeader.TypeFlag = 1999801;
				MyBoneInfHeader.DataSize = sizeof(VRawBoneInfluence);
				MyBoneInfHeader.DataCount = wcount;

				//do influences here

				TMCCountedPtr<FacetMesh> fmesh;
				//prim->GetFMesh(0.0,&fmesh);
				mypolym->GetPolyMeshFacetMesh(&fmesh);

				VVertexUn MyVVertex[7000];
				TVector3 vvposn[7000],tempvvposn[7000];

				long numvertices;
				//numvertices = fmesh->VerticesNbr();
				//(*stream)<<"vvertices\n";
				//(*stream)<<numvertices;
				//(*stream)<<"\n";
				//
				// build unique vvertex here - still no good, need get vertex uv elsewhere, not facetmesh
				//		see problem need material as well as uv and xyz to make unique
				//
				//
				int myUVi,vvmatch,i,j,k,numMat=0,curMat;
				TVector2 MyUv;
				float dx,dy,dz,du,dv,vsmall;
				vsmall=(float) 0.00001;

				//				int MyUvSpaceId;

				// now do faces and fill in missing info
				IPolygon *pmypoly;
				I3DExVertex *pmyvertex;
				long numFaces = mypolym->GetNbPolygons(),pointi;
				/*
				(*stream)<<"faces\n";
				(*stream)<<numFaces;
				(*stream)<<"\n";
				*/

				strcpy(MyVTriangleHeader.ChunkID,"FACE0000");
				MyVTriangleHeader.TypeFlag = 1999801;
				MyVTriangleHeader.DataSize = sizeof(VTriangle);
				MyVTriangleHeader.DataCount = numFaces;

				bool newMat, vvmatchfound;
				int curShad;

				numvertices=0;

				for(long findex=0;findex<numFaces;findex++)
				{
					pmypoly = mypolym->GetPolygonNoAddRef(findex);
					// guess same as uvspaceid but don't save cause several uvspaceid refer to same texture file name
					// need to build list with texture names
					curShad=pmypoly->GetShadingDomainID();// guess same as uvspaceid
					/*
					(*stream)<<"shading domain = \n";
					(*stream)<<curShad;
					(*stream)<<"\n";
					*/

					shader->GetOriginalParametricTextureMap(curShad,kUVMapColorIndex, &colorMap);
					if(colorMap)
					{
						if(!colorMap->IsInternalMode())
						{
							colorMap->GetFile(&mapFile, mapFormat);
							//use getbasename to get name without extension
							mapFile->GetBaseName(name3);
							name3.ToCPtr(mytextfilename);
						}
					}
					else name2.ToCPtr(mytextfilename);//use master shader name if no texture file
					// build first material
					// maybe have compare before and do below if first or not first and not match
					newMat=true;
					if(findex!=0) 
					{
						for(i=0;i<numMat;i++)
						{
							if(strcmp(MyVMaterial[i].MaterialName,mytextfilename)==0) 
							{
								newMat = false;
								curMat = i;
							}
						}
					}
					if(newMat)
					{
						strcpy(MyVMaterial[numMat].MaterialName,mytextfilename);
						MyVMaterial[numMat].TextureIndex = numMat;
						MyVMaterial[numMat].PolyFlags = numMat;
						MyVMaterial[numMat].AuxMaterial = 0;
						MyVMaterial[numMat].AuxFlags = 0;
						MyVMaterial[numMat].LodBias = 5;
						MyVMaterial[numMat].LodStyle = 0;
						curMat = numMat;
						numMat = numMat + 1;
						/*
						(*stream)<<"found texture name = \n";
						(*stream)<<mytextfilename;
						(*stream)<<"\n";
						*/
					}

					// always 3 vertices
					for(i=0;i<3;i++)
					{
						myUVi = pmypoly->GetUVIndexForVertex(i); 
						pmyvertex = pmypoly->GetVertex(i);
						MyUv = pmyvertex->GetUV(myUVi);
						//while(MyUv.x > 1) MyUv.x = MyUv.x - 1;
						//while(MyUv.y > 1) MyUv.y = MyUv.y - 1;
						//pointi = pmyvertex->GetIndex();//this does not work
						pmyvertex->GetPosition(vertPos);
						MyTransform.Transform(vertPos,vertPosT);
						// since getindex didnt work
						// get vvertex point index
						for(k=0;k<MyPointHeader.DataCount;k++)
						{
							dx = fabs(vertPosT.x - MyVPoint[k].Point.X);
							dy = fabs(vertPosT.y - MyVPoint[k].Point.Y);
							dz = fabs(vertPosT.z - MyVPoint[k].Point.Z);
							if(dx<vsmall && dy<vsmall && dz<vsmall)
							{
								pointi=k;
							}
						}

						//if not first face do compare
						if(findex!=0)
						{
							vvmatchfound = false;
							for(j=0;j<numvertices;j++)
							{
								//compare and set index and material in vvertex and save last good match for vtriangle
								du = fabs(MyVVertex[j].U - MyUv.x);
								dv = fabs(MyVVertex[j].V - MyUv.y);
								//if(pointi==MyVVertex[j].PointIndex && du<vsmall && dv<vsmall && curShad == MyVVertex[j].MatIndex)

								if(pointi==MyVVertex[j].PointIndex && du<vsmall && dv<vsmall && curMat == MyVVertex[j].MatIndex)
								{
									vvmatch = j;
									vvmatchfound = true;
								}
							}
							// no match so add to vvertex list
							if(!vvmatchfound)
							{
								MyVVertex[numvertices].PointIndex = pointi;
								MyVVertex[numvertices].U = MyUv.x;
								MyVVertex[numvertices].V = MyUv.y;
								//MyVVertex[numvertices].MatIndex = curShad;
								MyVVertex[numvertices].MatIndex = curMat;
								MyVVertex[numvertices].Reserved = 0;
								//triangle
								MyVTriangle[findex].WedgeIndex[2-i] = numvertices;//fix inside out dec 26 2004
								numvertices = numvertices + 1;
							}
							else
							{
								//triangle
								MyVTriangle[findex].WedgeIndex[2-i] = vvmatch;//fix inside out dec 26 2004
							}
						}
						// build first 3 vvertex from first face
						else
						{
							MyVVertex[i].PointIndex = pointi;
							MyVVertex[i].U = MyUv.x;
							MyVVertex[i].V = MyUv.y;
							//MyVVertex[i].MatIndex = curShad;
							MyVVertex[i].MatIndex = curMat;
							MyVVertex[i].Reserved = 0;
							//triangle
							MyVTriangle[findex].WedgeIndex[2-i] = i;//fix inside out dec 26 2004
							numvertices = numvertices + 1;
						}
					}
					//MyVTriangle[findex].MatIndex = curShad;
					MyVTriangle[findex].MatIndex = curMat;
					MyVTriangle[findex].AuxMatIndex = 0;
					MyVTriangle[findex].SmoothingGroups = 0;
				}
				for(i=0;i<numvertices;i++) MyVVertex[i].V = 1.0 - MyVVertex[i].V;//try fix upside down texture 27-dec-04
				strcpy(MyWedgeHeader.ChunkID,"VTXW0000");
				MyWedgeHeader.TypeFlag = 1999801;
				MyWedgeHeader.DataSize = sizeof(VVertexUn);
				MyWedgeHeader.DataCount = numvertices;

				strcpy(MyVMatHeader.ChunkID,"MATT0000");
				MyVMatHeader.TypeFlag = 1999801;
				MyVMatHeader.DataSize = sizeof(VMaterial);
				MyVMatHeader.DataCount = numMat;



				strcpy(MyBoneHeader.ChunkID,"REFSKELT");
				MyBoneHeader.TypeFlag = 1999801;
				MyBoneHeader.DataSize = sizeof(VBone);
				MyBoneHeader.DataCount = SkelIndex + 1;

				// ouptut to debug file
				/*
				for(j=0;j<MyWedgeHeader.DataCount;j++)
				{
					sprintf(szBuffer,"vvertex %i  point index %i mat ind %i\n",j,MyVVertex[j].PointIndex,MyVVertex[j].MatIndex);
					(*stream)<<szBuffer;
				}

				(*stream)<<"\n";
				*/

				delete stream;
				// end debug write


				if((fp=fopen(szFileName,"wb")) != NULL)
				{
					fwrite(&MyFileHeader,sizeof(VChunkHeader),1,fp);
					//points
					fwrite(&MyPointHeader,sizeof(VChunkHeader),1,fp);
					fwrite(&MyVPoint,sizeof(VPoint),MyPointHeader.DataCount,fp);
					// vertices/uv
					fwrite(&MyWedgeHeader,sizeof(VChunkHeader),1,fp);
					fwrite(&MyVVertex,sizeof(VVertexUn),MyWedgeHeader.DataCount,fp);

					fwrite(&MyVTriangleHeader,sizeof(VChunkHeader),1,fp);
					fwrite(&MyVTriangle,sizeof(VTriangle),MyVTriangleHeader.DataCount,fp);

					fwrite(&MyVMatHeader,sizeof(VChunkHeader),1,fp);
					fwrite(&MyVMaterial,sizeof(VMaterial),MyVMatHeader.DataCount,fp);

					fwrite(&MyBoneHeader,sizeof(VChunkHeader),1,fp);
					fwrite(&MyVBone,sizeof(VBone),MyBoneHeader.DataCount,fp);

					fwrite(&MyBoneInfHeader,sizeof(VChunkHeader),1,fp);
					fwrite(&MyBoneInf,sizeof(VRawBoneInfluence),MyBoneInfHeader.DataCount,fp);


					fclose(fp);
				}
				//write animation file
				WriteAnim();

			}
			// end of binary file
		}

		gShellUtilities->EndProgress(progressKey);
	}
	catch (TMCException& exception)
	{
		delete stream;
		gShellUtilities->EndProgress(progressKey);
		throw exception;
	}
	return MC_S_OK;
}
/*
void oldBuildAnim(TMCfstream* stream, bool PSAtest)
{
	char szBuffer[192];
	int32 timeLineCount = SkelTIndex+4;
	TMatrix33 MyMatrix, MyInvMatrix;
	TUnitQuaternion MyQuat;

	(*stream)<<"time line count is ";
	(*stream)<<timeLineCount;
	(*stream)<<"\n";

	TMCClassArray<TTimeInfo> lastKeyFrame;
	lastKeyFrame.SetElemCount(timeLineCount);

	int32 i=0;
	int32 ii,iii=0;
	float timeInSeconds=0;

	for (i=0;i<timeLineCount;i++)
	{
		lastKeyFrame[i].SetToBeforeAll();
	}
	MicroTick time = -1;
	MicroTick previousTime = -2;
	MicroTick ticksPerFrame;

	ticksPerFrame = real(kTicksPerSecond)/18;//assume 18 fps

	while (time > previousTime)
	{
		previousTime= time;

		// first we look for the smallest keyFrame of X,Y,Z that is bigger than previousTime
		// ( note that we export one keyFrame for the 3 coordinates )
		for (i=0;i<timeLineCount;i++)
		{
			if ( lastKeyFrame[i].GetTime() <= previousTime )
			{
				TMCCountedPtr<I3DShTweenerChainLink> tweenerChainLink;
				TTimeInfo newKeyFrame;

				pMyTimeLine[i]->WhenIsNextKeyFrame(lastKeyFrame[i],newKeyFrame,&tweenerChainLink);

				lastKeyFrame[i] = newKeyFrame;

				MicroTick newTime = newKeyFrame.GetTime();

				(*stream)<<"line newtime prevtime time ";
				(*stream)<<i;
				(*stream)<<" ";
				(*stream)<<newTime;
				(*stream)<<" ";
				(*stream)<<previousTime;
				(*stream)<<" ";
				(*stream)<<time;
				(*stream)<<" ";
				(*stream)<<"\n";

				// newTime > previousTime enforces that we move forward in time
				// time==previousTime makes sure that we get one first value
				// newTime < time makes sure we get the smallest time possible
				if (newTime > previousTime && (time==previousTime || newTime < time))
				{
					time = newTime;
				}
			}
		}

		// if we have been able to find a new keyFrame
		if (time > previousTime)
		{
			// we have a new keyFrame
			TVector3 keyFrameValue(0,0,0);

			TMCCountedPtr<I3DShTweenerChainLink> tweenerChainLink;
			for (i=0;i<timeLineCount;i++)
			{
				pMyTimeLine[i]->GetPreviousLink(time,&tweenerChainLink);

				ii = i%4;//x,y,z,rotation
				TMCCountedPtr<I3DShKeyFrame> keyFrame;

				// if xyz if rotation use kMatrix33ParamType
				if(ii<3) gShell3DUtilities->CreateKeyFrame(&keyFrame,kReal32ParamType);
				if(ii==3) gShell3DUtilities->CreateKeyFrame(&keyFrame,kMatrix33ParamType);

				if (MCVerify(keyFrame&&tweenerChainLink))
				{
					// check if the keyframe is the last of the list or not
					if(tweenerChainLink->GetNextNoAddRef())
					{
						TMCCountedPtr<I3DShTweener> tweener;

						tweenerChainLink->GetTweener(&tweener, true);
						if (MCVerify(tweener))
						{
							// do the interpolation using the tweener
							tweener->Tween(keyFrame, time, tweenerChainLink);
						}
					}
					else
					{
						keyFrame->LinearInterpolate(kRealZero,
							tweenerChainLink->GetKeyFrameNoAddRef(),
							tweenerChainLink->GetKeyFrameNoAddRef());
					}

					boolean changed= false;
					real value=0.0f;// only xyz need matrix33 for rotation
					TMatrix33 Rvalue;

					if(ii<3) keyFrame->GetParam(&value,kReal32ParamType,changed);
					if(ii==3) keyFrame->GetParam(&Rvalue,kMatrix33ParamType,changed);

					if(ii==0) MyAnimKey[iii].Position.X = value;
					if(ii==1) MyAnimKey[iii].Position.Y = value;
					if(ii==2) MyAnimKey[iii].Position.Z = value;
					if(ii==3)
					{
						MyQuat.SetFromMatrix(Rvalue);
						MyAnimKey[iii].Orientation.W = MyQuat.GetT();
						MyAnimKey[iii].Orientation.X = MyQuat.GetX();
						MyAnimKey[iii].Orientation.Y = MyQuat.GetY();
						MyAnimKey[iii].Orientation.Z = MyQuat.GetZ();

						MyAnimKey[iii].Time = time - previousTime;

						timeInSeconds = 18 * real(time) / real(kTicksPerSecond);
						(*stream)<<"time frame is ";
						(*stream)<<timeInSeconds;
						(*stream)<<"\n";

						sprintf(szBuffer,"bone %i posn (xyz)  %f, %f, %f\n\n", iii, MyAnimKey[iii].Position.X, 
							MyAnimKey[iii].Position.Y, MyAnimKey[iii].Position.Z);
						(*stream)<<szBuffer;
						sprintf(szBuffer,"bone %i quat(txyz)   %f, %f, %f, %f\n\n", iii, MyQuat.GetT(), MyQuat.GetX(), MyQuat.GetY(), MyQuat.GetZ());
						(*stream)<<szBuffer;

						iii = iii + 1;//unreal key count

					}
				}//keyFrame
			}

			float timeInSeconds = real(time) / real(kTicksPerSecond);

			//keyFrameValue is now ready

		} // if (time > previous Time )
	}
	float MyFR = gShell3DUtilities->GetPreferedFrameRate();
	for (i=0;i<iii;i++)
	{
		MyAnimKey[i].Time = 18 * MyAnimKey[i].Time / real(kTicksPerSecond);// hardcode 18fps for now
	}
	MyAnimInfo[0].KeyQuotum = iii;//num bones * num frames
	MyAnimInfo[0].TrackTime = MyAnimKey[iii-1].Time;// in frames
	
	(*stream)<<"last key time is ";
	(*stream)<<time;
	(*stream)<<"\n";
	(*stream)<<"ktickspersecond is ";
	(*stream)<<kTicksPerSecond;
	(*stream)<<"\n time in seconds is ";
	(*stream)<<timeInSeconds;
	(*stream)<<"\n";
	(*stream)<<"frame rate is ";
	(*stream)<<MyFR;
	(*stream)<<"\n";

}
*/